#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include "adlib.h"

extern "C" {
#include <mpi.h>
#include <stdio.h>
#include "adlibP_Adlib.h"
int len = 0;
char** sargs = 0;
}

void adlibP_Adlib_Finalize(struct HadlibP_Adlib *th) {
  int i;
//  printf("AdlibFinalize...\n");
  AdlibFinalize(); 
  for (i=0; i<len; i++)
    free(sargs[i]);
  free(sargs);
}

void adlibP_Adlib_Init(struct HadlibP_Adlib *th, HArrayOfString *args)  {
  int i;

  HString **data = unhand(args)->body;
  len = obj_length(args);
  sargs = (char**)calloc(len+1, sizeof(char*));
  for (i=0; i<len; i++)
    sargs[i] = allocCString(data[i]);
  sargs[len] = 0;
//  printf("AdlibInit...\n");
  AdlibInit(len, sargs);
}
